import { __decorate } from 'tslib';
import { EventEmitter, ViewChild, Output, Input, Component, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

var StimulsoftDesignerComponent = /** @class */ (function () {
    function StimulsoftDesignerComponent() {
        /**
         * Occurs when designer loaded
         */
        this.designerLoaded = new EventEmitter();
        this.id = 'aDesigner' + (Math.random() * 10000000).toString();
        this.loaded = false;
    }
    StimulsoftDesignerComponent.prototype.ngOnInit = function () {
        this.addScript();
    };
    StimulsoftDesignerComponent.prototype.ngOnChanges = function (changes) {
        this.addScript();
    };
    StimulsoftDesignerComponent.prototype.addScript = function () {
        var _this = this;
        if (this.chartScripts) {
            this.head.removeChild(this.chartScripts);
        }
        this.chartScripts = document.createElement('Script');
        this.chartScripts.setAttribute('type', 'text/javascript');
        this.chartScripts.src = this.requestUrl;
        this.chartScripts.addEventListener('load', function () {
            if (!_this.loaded) {
                try {
                    var options = new Stimulsoft.Designer.StiDesignerOptions();
                    _this.loaded = true;
                    setTimeout(function () {
                        _this.designerLoaded.next();
                    });
                    _this.showDesigner();
                }
                catch (_a) { }
            }
        });
        this.head.appendChild(this.chartScripts);
    };
    StimulsoftDesignerComponent.prototype.showDesigner = function () {
        var options = new Stimulsoft.Designer.StiDesignerOptions();
        if (this.width) {
            options.width = this.width;
        }
        if (this.height) {
            options.height = this.height;
        }
        this.designer = new Stimulsoft.Designer.StiDesigner(options, 'StiDesigner', false);
        this.designer.renderHtml(this.designerEl.nativeElement);
    };
    Object.defineProperty(StimulsoftDesignerComponent.prototype, "head", {
        get: function () {
            return document.getElementsByTagName('head')[0];
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        ViewChild('designer')
    ], StimulsoftDesignerComponent.prototype, "designerEl", void 0);
    __decorate([
        Output()
    ], StimulsoftDesignerComponent.prototype, "designerLoaded", void 0);
    __decorate([
        Input()
    ], StimulsoftDesignerComponent.prototype, "requestUrl", void 0);
    __decorate([
        Input()
    ], StimulsoftDesignerComponent.prototype, "width", void 0);
    __decorate([
        Input()
    ], StimulsoftDesignerComponent.prototype, "height", void 0);
    StimulsoftDesignerComponent = __decorate([
        Component({
            selector: 'stimulsoft-designer-angular',
            template: "\n    <div #designer [attr.id]=\"id\">\n      <ng-content></ng-content>\n    </div>\n  "
        })
    ], StimulsoftDesignerComponent);
    return StimulsoftDesignerComponent;
}());

var StimulsoftDesignerModule = /** @class */ (function () {
    function StimulsoftDesignerModule() {
    }
    StimulsoftDesignerModule = __decorate([
        NgModule({
            declarations: [StimulsoftDesignerComponent],
            imports: [
                CommonModule
            ],
            exports: [StimulsoftDesignerComponent]
        })
    ], StimulsoftDesignerModule);
    return StimulsoftDesignerModule;
}());

/*
 * Public API Surface of stimulsoft-designer-angular
 */

/**
 * Generated bundle index. Do not edit.
 */

export { StimulsoftDesignerComponent, StimulsoftDesignerModule };
//# sourceMappingURL=stimulsoft-designer-angular.js.map
